/****************************************************************************
** Generated from 'Connectivity.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/


#ifndef CONNECTIVITY_WIFI_H_
#define CONNECTIVITY_WIFI_H_

#include "connectivitymodule.h"

#include "accesspoint.h"

#include <QtIviCore/QIviAbstractFeature>
#include <QtIviCore/QIviPendingReply>
#include <QtIviCore/QIviPagingModel>

QT_BEGIN_NAMESPACE

class WiFiPrivate;
class WiFiBackendInterface;

class Q_CONNECTIVITY_EXPORT WiFi : public QIviAbstractFeature
{
    Q_OBJECT
    Q_PROPERTY(bool available READ available NOTIFY availableChanged)
    Q_PROPERTY(bool enabled READ enabled WRITE setEnabled NOTIFY enabledChanged)
    Q_PROPERTY(bool hotspotEnabled READ hotspotEnabled WRITE setHotspotEnabled NOTIFY hotspotEnabledChanged)
    Q_PROPERTY(QString hotspotSSID READ hotspotSSID WRITE setHotspotSSID NOTIFY hotspotSSIDChanged)
    Q_PROPERTY(QString hotspotPassword READ hotspotPassword WRITE setHotspotPassword NOTIFY hotspotPasswordChanged)
    Q_PROPERTY(QVariantList accessPoints READ accessPoints NOTIFY accessPointsChanged)
    Q_PROPERTY(ConnectivityModule::ConnectionStatus connectionStatus READ connectionStatus NOTIFY connectionStatusChanged)
    Q_PROPERTY(AccessPoint activeAccessPoint READ activeAccessPoint NOTIFY activeAccessPointChanged)
    Q_PROPERTY(QString errorString READ errorString NOTIFY errorStringChanged)

public:
    explicit WiFi(QObject *parent = nullptr);
    ~WiFi();

    static void registerQmlTypes(const QString& uri, int majorVersion=1, int minorVersion=0);

    bool available() const;
    bool enabled() const;
    bool hotspotEnabled() const;
    QString hotspotSSID() const;
    QString hotspotPassword() const;
    QVariantList accessPoints() const;
    ConnectivityModule::ConnectionStatus connectionStatus() const;
    AccessPoint activeAccessPoint() const;
    QString errorString() const;

public Q_SLOTS:
    QIviPendingReply<void> connectToAccessPoint(const QString &ssid);
    QIviPendingReply<void> disconnectFromAccessPoint(const QString &ssid);
    QIviPendingReply<void> sendCredentials(const QString &ssid, const QString &password);
    void setEnabled(bool enabled);
    void setHotspotEnabled(bool hotspotEnabled);
    void setHotspotSSID(const QString &hotspotSSID);
    void setHotspotPassword(const QString &hotspotPassword);

Q_SIGNALS:
    void credentialsRequested(const QString &ssid);
    void availableChanged(bool available);
    void enabledChanged(bool enabled);
    void hotspotEnabledChanged(bool hotspotEnabled);
    void hotspotSSIDChanged(const QString &hotspotSSID);
    void hotspotPasswordChanged(const QString &hotspotPassword);
    void accessPointsChanged(const QVariantList &accessPoints);
    void connectionStatusChanged(ConnectivityModule::ConnectionStatus connectionStatus);
    void activeAccessPointChanged(const AccessPoint &activeAccessPoint);
    void errorStringChanged(const QString &errorString);

protected:
    WiFiBackendInterface *wifiBackend() const;

    void connectToServiceObject(QIviServiceObject *service) Q_DECL_OVERRIDE;
    void clearServiceObject() Q_DECL_OVERRIDE;

private:
    Q_PRIVATE_SLOT(d_func(), void onAvailableChanged(bool available))
    Q_PRIVATE_SLOT(d_func(), void onEnabledChanged(bool enabled))
    Q_PRIVATE_SLOT(d_func(), void onHotspotEnabledChanged(bool hotspotEnabled))
    Q_PRIVATE_SLOT(d_func(), void onHotspotSSIDChanged(const QString &hotspotSSID))
    Q_PRIVATE_SLOT(d_func(), void onHotspotPasswordChanged(const QString &hotspotPassword))
    Q_PRIVATE_SLOT(d_func(), void onAccessPointsChanged(const QVariantList &accessPoints))
    Q_PRIVATE_SLOT(d_func(), void onConnectionStatusChanged(ConnectivityModule::ConnectionStatus connectionStatus))
    Q_PRIVATE_SLOT(d_func(), void onActiveAccessPointChanged(const AccessPoint &activeAccessPoint))
    Q_PRIVATE_SLOT(d_func(), void onErrorStringChanged(const QString &errorString))
    Q_DECLARE_PRIVATE(WiFi)
};

QT_END_NAMESPACE

#endif // CONNECTIVITY_WIFI_H_
