/****************************************************************************
** Generated from 'DriveData.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#include "navigationstatebackend.h"

#include <QDebug>
#include <QSettings>
#include <QTimer>
#include "drivedatamodule.h"

Q_LOGGING_CATEGORY(qLcRONavigationState, "shared.com.pelagicore.drivedata.navigationstatebackend.remoteobjects", QtInfoMsg)


QT_BEGIN_NAMESPACE


NavigationStateBackend::NavigationStateBackend(const QString &remoteObjectsLookupName, QObject *parent)
    : NavigationStateBackendInterface(parent)
    , m_node(nullptr)
    , m_remoteObjectsLookupName(remoteObjectsLookupName)
    , m_helper(new QIviRemoteObjectReplicaHelper(qLcRONavigationState(), this))
{
    DriveDataModule::registerTypes();

}

NavigationStateBackend::~NavigationStateBackend()
{
    delete m_node;
}

void NavigationStateBackend::initialize()
{

    if (!connectToNode())
        return;

    if (m_replica->isInitialized()) {
        Q_EMIT mapCenterChanged(m_replica->mapCenter());
        Q_EMIT mapZoomLevelChanged(m_replica->mapZoomLevel());
        Q_EMIT mapTiltChanged(m_replica->mapTilt());
        Q_EMIT mapBearingChanged(m_replica->mapBearing());
        Q_EMIT nextTurnChanged(m_replica->nextTurn());
        Q_EMIT nextTurnDistanceMeasuredInChanged(m_replica->nextTurnDistanceMeasuredIn());
        Q_EMIT nextTurnDistanceChanged(m_replica->nextTurnDistance());
        Q_EMIT routePointsChanged(m_replica->routePoints());
        Q_EMIT initializationDone();
    }

    QTimer::singleShot(3000, this, [this](){
        if(!m_replica->isInitialized())
            qCCritical(qLcRONavigationState) << "DriveData.NavigationState wasn't initialized within the timeout period. Please make sure the server is running.";
    });
}


void NavigationStateBackend::setMapCenter(const QVariant &mapCenter)
{
    if (m_replica.isNull())
        return;
    m_replica->pushMapCenter(mapCenter);
}

void NavigationStateBackend::setMapZoomLevel(qreal mapZoomLevel)
{
    if (m_replica.isNull())
        return;
    m_replica->pushMapZoomLevel(mapZoomLevel);
}

void NavigationStateBackend::setMapTilt(qreal mapTilt)
{
    if (m_replica.isNull())
        return;
    m_replica->pushMapTilt(mapTilt);
}

void NavigationStateBackend::setMapBearing(qreal mapBearing)
{
    if (m_replica.isNull())
        return;
    m_replica->pushMapBearing(mapBearing);
}

void NavigationStateBackend::setNextTurn(const QString &nextTurn)
{
    if (m_replica.isNull())
        return;
    m_replica->pushNextTurn(nextTurn);
}

void NavigationStateBackend::setNextTurnDistanceMeasuredIn(const QString &nextTurnDistanceMeasuredIn)
{
    if (m_replica.isNull())
        return;
    m_replica->pushNextTurnDistanceMeasuredIn(nextTurnDistanceMeasuredIn);
}

void NavigationStateBackend::setNextTurnDistance(qreal nextTurnDistance)
{
    if (m_replica.isNull())
        return;
    m_replica->pushNextTurnDistance(nextTurnDistance);
}

void NavigationStateBackend::setRoutePoints(const QVariant &routePoints)
{
    if (m_replica.isNull())
        return;
    m_replica->pushRoutePoints(routePoints);
}



bool NavigationStateBackend::connectToNode()
{
    static QString configPath;
    if (configPath.isEmpty()) {
        if (qEnvironmentVariableIsSet("SERVER_CONF_PATH")) {
            configPath = QString::fromLocal8Bit(qgetenv("SERVER_CONF_PATH"));
        } else {
            configPath = QStringLiteral("./server.conf");
            qCInfo(qLcRONavigationState) << "Environment variable SERVER_CONF_PATH not defined, using " << configPath;
        }
    }

    QSettings settings(configPath, QSettings::IniFormat);
    settings.beginGroup(QStringLiteral("drivedata"));
    QUrl registryUrl = QUrl(settings.value(QStringLiteral("Registry"), QStringLiteral("local:drivedata")).toString());
    if (m_url != registryUrl) {
        m_url = registryUrl;
        // QtRO doesn't allow to change the URL without destroying the Node
        delete m_node;
        m_node = new QRemoteObjectNode();
        if (!m_node->connectToNode(m_url)) {
            qCCritical(qLcRONavigationState) << "Connection to" << m_url << "failed!";
            m_replica.reset();
            return false;
        }
        qCInfo(qLcRONavigationState) << "Connecting to" << m_url;
        m_replica.reset(m_node->acquire<NavigationStateReplica>(m_remoteObjectsLookupName));
        setupConnections();
    }
    return true;
}

void NavigationStateBackend::setupConnections()
{
    connect(m_node, &QRemoteObjectNode::error, m_helper, &QIviRemoteObjectReplicaHelper::onNodeError);
    connect(m_helper, &QIviRemoteObjectReplicaHelper::errorChanged, this, &QIviFeatureInterface::errorChanged);

    connect(m_replica.data(), &QRemoteObjectReplica::stateChanged, m_helper, &QIviRemoteObjectReplicaHelper::onReplicaStateChanged);
    connect(m_replica.data(), &NavigationStateReplica::pendingResultAvailable, m_helper, &QIviRemoteObjectReplicaHelper::onPendingResultAvailable);
    //As the Replica is now initialized, this will trigger an update of all properties (not just the changed ones)
    connect(m_replica.data(), &QRemoteObjectReplica::initialized, this, &NavigationStateBackend::initialize);
    connect(m_replica.data(), &NavigationStateReplica::mapCenterChanged, this, &NavigationStateBackend::mapCenterChanged);
    connect(m_replica.data(), &NavigationStateReplica::mapZoomLevelChanged, this, &NavigationStateBackend::mapZoomLevelChanged);
    connect(m_replica.data(), &NavigationStateReplica::mapTiltChanged, this, &NavigationStateBackend::mapTiltChanged);
    connect(m_replica.data(), &NavigationStateReplica::mapBearingChanged, this, &NavigationStateBackend::mapBearingChanged);
    connect(m_replica.data(), &NavigationStateReplica::nextTurnChanged, this, &NavigationStateBackend::nextTurnChanged);
    connect(m_replica.data(), &NavigationStateReplica::nextTurnDistanceMeasuredInChanged, this, &NavigationStateBackend::nextTurnDistanceMeasuredInChanged);
    connect(m_replica.data(), &NavigationStateReplica::nextTurnDistanceChanged, this, &NavigationStateBackend::nextTurnDistanceChanged);
    connect(m_replica.data(), &NavigationStateReplica::routePointsChanged, this, &NavigationStateBackend::routePointsChanged);
}


QT_END_NAMESPACE
