#ifndef REP_INSTRUMENTCLUSTER_REPLICA_H
#define REP_INSTRUMENTCLUSTER_REPLICA_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>

#include "drivedatamodule.h"

class InstrumentClusterReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "InstrumentCluster")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "ac1e1b340ca0d46bff5376e1164bf5feb511ec99")
    Q_PROPERTY(bool enableSimulation READ enableSimulation NOTIFY enableSimulationChanged)
    Q_PROPERTY(qreal speed READ speed NOTIFY speedChanged)
    Q_PROPERTY(qreal speedLimit READ speedLimit NOTIFY speedLimitChanged)
    Q_PROPERTY(qreal speedCruise READ speedCruise NOTIFY speedCruiseChanged)
    Q_PROPERTY(qreal ePower READ ePower NOTIFY ePowerChanged)
    Q_PROPERTY(int driveTrainState READ driveTrainState NOTIFY driveTrainStateChanged)
    Q_PROPERTY(bool lowBeamHeadlight READ lowBeamHeadlight NOTIFY lowBeamHeadlightChanged)
    Q_PROPERTY(bool highBeamHeadlight READ highBeamHeadlight NOTIFY highBeamHeadlightChanged)
    Q_PROPERTY(bool fogLight READ fogLight NOTIFY fogLightChanged)
    Q_PROPERTY(bool stabilityControl READ stabilityControl NOTIFY stabilityControlChanged)
    Q_PROPERTY(bool seatBeltNotFastened READ seatBeltNotFastened NOTIFY seatBeltNotFastenedChanged)
    Q_PROPERTY(bool leftTurn READ leftTurn NOTIFY leftTurnChanged)
    Q_PROPERTY(bool rightTurn READ rightTurn NOTIFY rightTurnChanged)
    Q_PROPERTY(bool ABSFailure READ ABSFailure NOTIFY ABSFailureChanged)
    Q_PROPERTY(bool parkBrake READ parkBrake NOTIFY parkBrakeChanged)
    Q_PROPERTY(bool tyrePressureLow READ tyrePressureLow NOTIFY tyrePressureLowChanged)
    Q_PROPERTY(bool brakeFailure READ brakeFailure NOTIFY brakeFailureChanged)
    Q_PROPERTY(bool airbagFailure READ airbagFailure NOTIFY airbagFailureChanged)
    Q_PROPERTY(qreal outsideTemperatureCelsius READ outsideTemperatureCelsius NOTIFY outsideTemperatureCelsiusChanged)
    Q_PROPERTY(qreal mileageKm READ mileageKm NOTIFY mileageKmChanged)
    Q_PROPERTY(int drivingMode READ drivingMode NOTIFY drivingModeChanged)
    Q_PROPERTY(int drivingModeRangeKm READ drivingModeRangeKm NOTIFY drivingModeRangeKmChanged)
    Q_PROPERTY(int drivingModeECORangeKm READ drivingModeECORangeKm NOTIFY drivingModeECORangeKmChanged)
    Q_PROPERTY(qreal navigationProgressPercents READ navigationProgressPercents NOTIFY navigationProgressPercentsChanged)
    Q_PROPERTY(qreal navigationRouteDistanceKm READ navigationRouteDistanceKm NOTIFY navigationRouteDistanceKmChanged)
    Q_PROPERTY(bool available READ available NOTIFY availableChanged)

public:
    InstrumentClusterReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<void>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>();

    }

private:
    InstrumentClusterReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        InstrumentClusterReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(26);
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(int());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(int());
        properties << QVariant::fromValue(int());
        properties << QVariant::fromValue(int());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(bool());
        setProperties(properties);
    }

public:
    ~InstrumentClusterReplica() override = default;

    bool enableSimulation() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property enableSimulation to type bool";
        }
        return variant.value<bool >();
    }

    qreal speed() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property speed to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal speedLimit() const
    {
        const QVariant variant = propAsVariant(2);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property speedLimit to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal speedCruise() const
    {
        const QVariant variant = propAsVariant(3);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property speedCruise to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal ePower() const
    {
        const QVariant variant = propAsVariant(4);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property ePower to type qreal";
        }
        return variant.value<qreal >();
    }

    int driveTrainState() const
    {
        const QVariant variant = propAsVariant(5);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property driveTrainState to type int";
        }
        return variant.value<int >();
    }

    bool lowBeamHeadlight() const
    {
        const QVariant variant = propAsVariant(6);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property lowBeamHeadlight to type bool";
        }
        return variant.value<bool >();
    }

    bool highBeamHeadlight() const
    {
        const QVariant variant = propAsVariant(7);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property highBeamHeadlight to type bool";
        }
        return variant.value<bool >();
    }

    bool fogLight() const
    {
        const QVariant variant = propAsVariant(8);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property fogLight to type bool";
        }
        return variant.value<bool >();
    }

    bool stabilityControl() const
    {
        const QVariant variant = propAsVariant(9);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property stabilityControl to type bool";
        }
        return variant.value<bool >();
    }

    bool seatBeltNotFastened() const
    {
        const QVariant variant = propAsVariant(10);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property seatBeltNotFastened to type bool";
        }
        return variant.value<bool >();
    }

    bool leftTurn() const
    {
        const QVariant variant = propAsVariant(11);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property leftTurn to type bool";
        }
        return variant.value<bool >();
    }

    bool rightTurn() const
    {
        const QVariant variant = propAsVariant(12);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property rightTurn to type bool";
        }
        return variant.value<bool >();
    }

    bool ABSFailure() const
    {
        const QVariant variant = propAsVariant(13);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property ABSFailure to type bool";
        }
        return variant.value<bool >();
    }

    bool parkBrake() const
    {
        const QVariant variant = propAsVariant(14);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property parkBrake to type bool";
        }
        return variant.value<bool >();
    }

    bool tyrePressureLow() const
    {
        const QVariant variant = propAsVariant(15);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property tyrePressureLow to type bool";
        }
        return variant.value<bool >();
    }

    bool brakeFailure() const
    {
        const QVariant variant = propAsVariant(16);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property brakeFailure to type bool";
        }
        return variant.value<bool >();
    }

    bool airbagFailure() const
    {
        const QVariant variant = propAsVariant(17);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property airbagFailure to type bool";
        }
        return variant.value<bool >();
    }

    qreal outsideTemperatureCelsius() const
    {
        const QVariant variant = propAsVariant(18);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property outsideTemperatureCelsius to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal mileageKm() const
    {
        const QVariant variant = propAsVariant(19);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property mileageKm to type qreal";
        }
        return variant.value<qreal >();
    }

    int drivingMode() const
    {
        const QVariant variant = propAsVariant(20);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property drivingMode to type int";
        }
        return variant.value<int >();
    }

    int drivingModeRangeKm() const
    {
        const QVariant variant = propAsVariant(21);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property drivingModeRangeKm to type int";
        }
        return variant.value<int >();
    }

    int drivingModeECORangeKm() const
    {
        const QVariant variant = propAsVariant(22);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property drivingModeECORangeKm to type int";
        }
        return variant.value<int >();
    }

    qreal navigationProgressPercents() const
    {
        const QVariant variant = propAsVariant(23);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property navigationProgressPercents to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal navigationRouteDistanceKm() const
    {
        const QVariant variant = propAsVariant(24);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property navigationRouteDistanceKm to type qreal";
        }
        return variant.value<qreal >();
    }

    bool available() const
    {
        const QVariant variant = propAsVariant(25);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property available to type bool";
        }
        return variant.value<bool >();
    }


Q_SIGNALS:
    void enableSimulationChanged(bool enableSimulation);
    void speedChanged(qreal speed);
    void speedLimitChanged(qreal speedLimit);
    void speedCruiseChanged(qreal speedCruise);
    void ePowerChanged(qreal ePower);
    void driveTrainStateChanged(int driveTrainState);
    void lowBeamHeadlightChanged(bool lowBeamHeadlight);
    void highBeamHeadlightChanged(bool highBeamHeadlight);
    void fogLightChanged(bool fogLight);
    void stabilityControlChanged(bool stabilityControl);
    void seatBeltNotFastenedChanged(bool seatBeltNotFastened);
    void leftTurnChanged(bool leftTurn);
    void rightTurnChanged(bool rightTurn);
    void ABSFailureChanged(bool ABSFailure);
    void parkBrakeChanged(bool parkBrake);
    void tyrePressureLowChanged(bool tyrePressureLow);
    void brakeFailureChanged(bool brakeFailure);
    void airbagFailureChanged(bool airbagFailure);
    void outsideTemperatureCelsiusChanged(qreal outsideTemperatureCelsius);
    void mileageKmChanged(qreal mileageKm);
    void drivingModeChanged(int drivingMode);
    void drivingModeRangeKmChanged(int drivingModeRangeKm);
    void drivingModeECORangeKmChanged(int drivingModeECORangeKm);
    void navigationProgressPercentsChanged(qreal navigationProgressPercents);
    void navigationRouteDistanceKmChanged(qreal navigationRouteDistanceKm);
    void availableChanged(bool available);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    void pushEnableSimulation(bool enableSimulation)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushEnableSimulation(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(enableSimulation);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushSpeed(qreal speed)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushSpeed(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(speed);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushSpeedLimit(qreal speedLimit)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushSpeedLimit(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(speedLimit);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushSpeedCruise(qreal speedCruise)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushSpeedCruise(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(speedCruise);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushEPower(qreal ePower)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushEPower(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(ePower);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushDriveTrainState(int driveTrainState)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushDriveTrainState(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(driveTrainState);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushLowBeamHeadlight(bool lowBeamHeadlight)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushLowBeamHeadlight(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(lowBeamHeadlight);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushHighBeamHeadlight(bool highBeamHeadlight)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushHighBeamHeadlight(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(highBeamHeadlight);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushFogLight(bool fogLight)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushFogLight(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(fogLight);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushStabilityControl(bool stabilityControl)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushStabilityControl(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(stabilityControl);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushSeatBeltNotFastened(bool seatBeltNotFastened)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushSeatBeltNotFastened(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(seatBeltNotFastened);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushLeftTurn(bool leftTurn)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushLeftTurn(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(leftTurn);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushRightTurn(bool rightTurn)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushRightTurn(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(rightTurn);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushABSFailure(bool ABSFailure)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushABSFailure(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(ABSFailure);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushParkBrake(bool parkBrake)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushParkBrake(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(parkBrake);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushTyrePressureLow(bool tyrePressureLow)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushTyrePressureLow(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(tyrePressureLow);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushBrakeFailure(bool brakeFailure)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushBrakeFailure(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(brakeFailure);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushAirbagFailure(bool airbagFailure)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushAirbagFailure(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(airbagFailure);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushOutsideTemperatureCelsius(qreal outsideTemperatureCelsius)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushOutsideTemperatureCelsius(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(outsideTemperatureCelsius);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushMileageKm(qreal mileageKm)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushMileageKm(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(mileageKm);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushDrivingMode(int drivingMode)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushDrivingMode(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(drivingMode);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushDrivingModeRangeKm(int drivingModeRangeKm)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushDrivingModeRangeKm(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(drivingModeRangeKm);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushDrivingModeECORangeKm(int drivingModeECORangeKm)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushDrivingModeECORangeKm(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(drivingModeECORangeKm);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushNavigationProgressPercents(qreal navigationProgressPercents)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushNavigationProgressPercents(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(navigationProgressPercents);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushNavigationRouteDistanceKm(qreal navigationRouteDistanceKm)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushNavigationRouteDistanceKm(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(navigationRouteDistanceKm);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushAvailable(bool available)
    {
        static int __repc_index = InstrumentClusterReplica::staticMetaObject.indexOfSlot("pushAvailable(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(available);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_INSTRUMENTCLUSTER_REPLICA_H
