#ifndef REP_NAVIGATIONSTATE_REPLICA_H
#define REP_NAVIGATIONSTATE_REPLICA_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>

#include "drivedatamodule.h"

class NavigationStateReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "NavigationState")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "4436408ae3c913e1e5513ada851bb80601a2596b")
    Q_PROPERTY(QVariant mapCenter READ mapCenter NOTIFY mapCenterChanged)
    Q_PROPERTY(qreal mapZoomLevel READ mapZoomLevel NOTIFY mapZoomLevelChanged)
    Q_PROPERTY(qreal mapTilt READ mapTilt NOTIFY mapTiltChanged)
    Q_PROPERTY(qreal mapBearing READ mapBearing NOTIFY mapBearingChanged)
    Q_PROPERTY(QString nextTurn READ nextTurn NOTIFY nextTurnChanged)
    Q_PROPERTY(QString nextTurnDistanceMeasuredIn READ nextTurnDistanceMeasuredIn NOTIFY nextTurnDistanceMeasuredInChanged)
    Q_PROPERTY(qreal nextTurnDistance READ nextTurnDistance NOTIFY nextTurnDistanceChanged)
    Q_PROPERTY(QVariant routePoints READ routePoints NOTIFY routePointsChanged)

public:
    NavigationStateReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<void>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>();

    }

private:
    NavigationStateReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        NavigationStateReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(8);
        properties << QVariant::fromValue(QVariant());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(QString());
        properties << QVariant::fromValue(QString());
        properties << QVariant::fromValue(qreal());
        properties << QVariant::fromValue(QVariant());
        setProperties(properties);
    }

public:
    ~NavigationStateReplica() override = default;

    QVariant mapCenter() const
    {
        return propAsVariant(0);
    }

    qreal mapZoomLevel() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property mapZoomLevel to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal mapTilt() const
    {
        const QVariant variant = propAsVariant(2);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property mapTilt to type qreal";
        }
        return variant.value<qreal >();
    }

    qreal mapBearing() const
    {
        const QVariant variant = propAsVariant(3);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property mapBearing to type qreal";
        }
        return variant.value<qreal >();
    }

    QString nextTurn() const
    {
        const QVariant variant = propAsVariant(4);
        if (!variant.canConvert<QString>()) {
            qWarning() << "QtRO cannot convert the property nextTurn to type QString";
        }
        return variant.value<QString >();
    }

    QString nextTurnDistanceMeasuredIn() const
    {
        const QVariant variant = propAsVariant(5);
        if (!variant.canConvert<QString>()) {
            qWarning() << "QtRO cannot convert the property nextTurnDistanceMeasuredIn to type QString";
        }
        return variant.value<QString >();
    }

    qreal nextTurnDistance() const
    {
        const QVariant variant = propAsVariant(6);
        if (!variant.canConvert<qreal>()) {
            qWarning() << "QtRO cannot convert the property nextTurnDistance to type qreal";
        }
        return variant.value<qreal >();
    }

    QVariant routePoints() const
    {
        return propAsVariant(7);
    }


Q_SIGNALS:
    void mapCenterChanged(QVariant mapCenter);
    void mapZoomLevelChanged(qreal mapZoomLevel);
    void mapTiltChanged(qreal mapTilt);
    void mapBearingChanged(qreal mapBearing);
    void nextTurnChanged(QString nextTurn);
    void nextTurnDistanceMeasuredInChanged(QString nextTurnDistanceMeasuredIn);
    void nextTurnDistanceChanged(qreal nextTurnDistance);
    void routePointsChanged(QVariant routePoints);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    void pushMapCenter(QVariant mapCenter)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushMapCenter(QVariant)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(mapCenter);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushMapZoomLevel(qreal mapZoomLevel)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushMapZoomLevel(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(mapZoomLevel);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushMapTilt(qreal mapTilt)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushMapTilt(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(mapTilt);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushMapBearing(qreal mapBearing)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushMapBearing(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(mapBearing);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushNextTurn(QString nextTurn)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushNextTurn(QString)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(nextTurn);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushNextTurnDistanceMeasuredIn(QString nextTurnDistanceMeasuredIn)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushNextTurnDistanceMeasuredIn(QString)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(nextTurnDistanceMeasuredIn);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushNextTurnDistance(qreal nextTurnDistance)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushNextTurnDistance(qreal)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(nextTurnDistance);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushRoutePoints(QVariant routePoints)
    {
        static int __repc_index = NavigationStateReplica::staticMetaObject.indexOfSlot("pushRoutePoints(QVariant)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(routePoints);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_NAVIGATIONSTATE_REPLICA_H
