#ifndef REP_NAVIGATIONSTATE_SOURCE_H
#define REP_NAVIGATIONSTATE_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include "drivedatamodule.h"

class NavigationStateSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "NavigationState")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "4436408ae3c913e1e5513ada851bb80601a2596b")
    Q_PROPERTY(QVariant mapCenter READ mapCenter WRITE setMapCenter NOTIFY mapCenterChanged)
    Q_PROPERTY(qreal mapZoomLevel READ mapZoomLevel WRITE setMapZoomLevel NOTIFY mapZoomLevelChanged)
    Q_PROPERTY(qreal mapTilt READ mapTilt WRITE setMapTilt NOTIFY mapTiltChanged)
    Q_PROPERTY(qreal mapBearing READ mapBearing WRITE setMapBearing NOTIFY mapBearingChanged)
    Q_PROPERTY(QString nextTurn READ nextTurn WRITE setNextTurn NOTIFY nextTurnChanged)
    Q_PROPERTY(QString nextTurnDistanceMeasuredIn READ nextTurnDistanceMeasuredIn WRITE setNextTurnDistanceMeasuredIn NOTIFY nextTurnDistanceMeasuredInChanged)
    Q_PROPERTY(qreal nextTurnDistance READ nextTurnDistance WRITE setNextTurnDistance NOTIFY nextTurnDistanceChanged)
    Q_PROPERTY(QVariant routePoints READ routePoints WRITE setRoutePoints NOTIFY routePointsChanged)

public:
    explicit NavigationStateSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~NavigationStateSource() override = default;

    virtual QVariant mapCenter() const = 0;
    virtual qreal mapZoomLevel() const = 0;
    virtual qreal mapTilt() const = 0;
    virtual qreal mapBearing() const = 0;
    virtual QString nextTurn() const = 0;
    virtual QString nextTurnDistanceMeasuredIn() const = 0;
    virtual qreal nextTurnDistance() const = 0;
    virtual QVariant routePoints() const = 0;
    virtual void setMapCenter(QVariant mapCenter) = 0;
    virtual void setMapZoomLevel(qreal mapZoomLevel) = 0;
    virtual void setMapTilt(qreal mapTilt) = 0;
    virtual void setMapBearing(qreal mapBearing) = 0;
    virtual void setNextTurn(QString nextTurn) = 0;
    virtual void setNextTurnDistanceMeasuredIn(QString nextTurnDistanceMeasuredIn) = 0;
    virtual void setNextTurnDistance(qreal nextTurnDistance) = 0;
    virtual void setRoutePoints(QVariant routePoints) = 0;

Q_SIGNALS:
    void mapCenterChanged(QVariant mapCenter);
    void mapZoomLevelChanged(qreal mapZoomLevel);
    void mapTiltChanged(qreal mapTilt);
    void mapBearingChanged(qreal mapBearing);
    void nextTurnChanged(QString nextTurn);
    void nextTurnDistanceMeasuredInChanged(QString nextTurnDistanceMeasuredIn);
    void nextTurnDistanceChanged(qreal nextTurnDistance);
    void routePointsChanged(QVariant routePoints);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual void pushMapCenter(QVariant mapCenter)
    {
        setMapCenter(mapCenter);
    }
    virtual void pushMapZoomLevel(qreal mapZoomLevel)
    {
        setMapZoomLevel(mapZoomLevel);
    }
    virtual void pushMapTilt(qreal mapTilt)
    {
        setMapTilt(mapTilt);
    }
    virtual void pushMapBearing(qreal mapBearing)
    {
        setMapBearing(mapBearing);
    }
    virtual void pushNextTurn(QString nextTurn)
    {
        setNextTurn(nextTurn);
    }
    virtual void pushNextTurnDistanceMeasuredIn(QString nextTurnDistanceMeasuredIn)
    {
        setNextTurnDistanceMeasuredIn(nextTurnDistanceMeasuredIn);
    }
    virtual void pushNextTurnDistance(qreal nextTurnDistance)
    {
        setNextTurnDistance(nextTurnDistance);
    }
    virtual void pushRoutePoints(QVariant routePoints)
    {
        setRoutePoints(routePoints);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class NavigationStateSimpleSource : public NavigationStateSource
{
    Q_OBJECT

public:
    explicit NavigationStateSimpleSource(QObject *parent = nullptr) : NavigationStateSource(parent)
    , m_mapCenter()
    , m_mapZoomLevel()
    , m_mapTilt()
    , m_mapBearing()
    , m_nextTurn()
    , m_nextTurnDistanceMeasuredIn()
    , m_nextTurnDistance()
    , m_routePoints()
    {
    }

public:
    ~NavigationStateSimpleSource() override = default;

    QVariant mapCenter() const override { return m_mapCenter; }
    qreal mapZoomLevel() const override { return m_mapZoomLevel; }
    qreal mapTilt() const override { return m_mapTilt; }
    qreal mapBearing() const override { return m_mapBearing; }
    QString nextTurn() const override { return m_nextTurn; }
    QString nextTurnDistanceMeasuredIn() const override { return m_nextTurnDistanceMeasuredIn; }
    qreal nextTurnDistance() const override { return m_nextTurnDistance; }
    QVariant routePoints() const override { return m_routePoints; }
    void setMapCenter(QVariant mapCenter) override
    {
        if (mapCenter != m_mapCenter) {
            m_mapCenter = mapCenter;
            Q_EMIT mapCenterChanged(m_mapCenter);
        }
    }
    void setMapZoomLevel(qreal mapZoomLevel) override
    {
        if (mapZoomLevel != m_mapZoomLevel) {
            m_mapZoomLevel = mapZoomLevel;
            Q_EMIT mapZoomLevelChanged(m_mapZoomLevel);
        }
    }
    void setMapTilt(qreal mapTilt) override
    {
        if (mapTilt != m_mapTilt) {
            m_mapTilt = mapTilt;
            Q_EMIT mapTiltChanged(m_mapTilt);
        }
    }
    void setMapBearing(qreal mapBearing) override
    {
        if (mapBearing != m_mapBearing) {
            m_mapBearing = mapBearing;
            Q_EMIT mapBearingChanged(m_mapBearing);
        }
    }
    void setNextTurn(QString nextTurn) override
    {
        if (nextTurn != m_nextTurn) {
            m_nextTurn = nextTurn;
            Q_EMIT nextTurnChanged(m_nextTurn);
        }
    }
    void setNextTurnDistanceMeasuredIn(QString nextTurnDistanceMeasuredIn) override
    {
        if (nextTurnDistanceMeasuredIn != m_nextTurnDistanceMeasuredIn) {
            m_nextTurnDistanceMeasuredIn = nextTurnDistanceMeasuredIn;
            Q_EMIT nextTurnDistanceMeasuredInChanged(m_nextTurnDistanceMeasuredIn);
        }
    }
    void setNextTurnDistance(qreal nextTurnDistance) override
    {
        if (nextTurnDistance != m_nextTurnDistance) {
            m_nextTurnDistance = nextTurnDistance;
            Q_EMIT nextTurnDistanceChanged(m_nextTurnDistance);
        }
    }
    void setRoutePoints(QVariant routePoints) override
    {
        if (routePoints != m_routePoints) {
            m_routePoints = routePoints;
            Q_EMIT routePointsChanged(m_routePoints);
        }
    }

private:
    QVariant m_mapCenter;
    qreal m_mapZoomLevel;
    qreal m_mapTilt;
    qreal m_mapBearing;
    QString m_nextTurn;
    QString m_nextTurnDistanceMeasuredIn;
    qreal m_nextTurnDistance;
    QVariant m_routePoints;
};


template <class ObjectType>
struct NavigationStateSourceAPI : public SourceApiMap
{
    NavigationStateSourceAPI(ObjectType *object, const QString &name = QLatin1String("NavigationState"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 8;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::mapCenter, static_cast<QVariant (QObject::*)()>(0),"mapCenter");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mapCenterChanged, static_cast<void (QObject::*)()>(0));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::mapZoomLevel, static_cast<qreal (QObject::*)()>(0),"mapZoomLevel");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mapZoomLevelChanged, static_cast<void (QObject::*)()>(0));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::mapTilt, static_cast<qreal (QObject::*)()>(0),"mapTilt");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mapTiltChanged, static_cast<void (QObject::*)()>(0));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::mapBearing, static_cast<qreal (QObject::*)()>(0),"mapBearing");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mapBearingChanged, static_cast<void (QObject::*)()>(0));
        m_properties[5] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::nextTurn, static_cast<QString (QObject::*)()>(0),"nextTurn");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::nextTurnChanged, static_cast<void (QObject::*)()>(0));
        m_properties[6] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::nextTurnDistanceMeasuredIn, static_cast<QString (QObject::*)()>(0),"nextTurnDistanceMeasuredIn");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::nextTurnDistanceMeasuredInChanged, static_cast<void (QObject::*)()>(0));
        m_properties[7] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::nextTurnDistance, static_cast<qreal (QObject::*)()>(0),"nextTurnDistance");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::nextTurnDistanceChanged, static_cast<void (QObject::*)()>(0));
        m_properties[8] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::routePoints, static_cast<QVariant (QObject::*)()>(0),"routePoints");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::routePointsChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 9;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mapCenterChanged, static_cast<void (QObject::*)(QVariant)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mapZoomLevelChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mapTiltChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mapBearingChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::nextTurnChanged, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::nextTurnDistanceMeasuredInChanged, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_signals[7] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::nextTurnDistanceChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+6,&m_signalArgTypes[6]);
        m_signals[8] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::routePointsChanged, static_cast<void (QObject::*)(QVariant)>(0),m_signalArgCount+7,&m_signalArgTypes[7]);
        m_signals[9] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+8,&m_signalArgTypes[8]);
        m_methods[0] = 8;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMapCenter, static_cast<void (QObject::*)(QVariant)>(0),"pushMapCenter(QVariant)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMapZoomLevel, static_cast<void (QObject::*)(qreal)>(0),"pushMapZoomLevel(qreal)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMapTilt, static_cast<void (QObject::*)(qreal)>(0),"pushMapTilt(qreal)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMapBearing, static_cast<void (QObject::*)(qreal)>(0),"pushMapBearing(qreal)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushNextTurn, static_cast<void (QObject::*)(QString)>(0),"pushNextTurn(QString)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushNextTurnDistanceMeasuredIn, static_cast<void (QObject::*)(QString)>(0),"pushNextTurnDistanceMeasuredIn(QString)",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushNextTurnDistance, static_cast<void (QObject::*)(qreal)>(0),"pushNextTurnDistance(qreal)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushRoutePoints, static_cast<void (QObject::*)(QVariant)>(0),"pushRoutePoints(QVariant)",m_methodArgCount+7,&m_methodArgTypes[7]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("NavigationState"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        case 3: return m_properties[4];
        case 4: return m_properties[5];
        case 5: return m_properties[6];
        case 6: return m_properties[7];
        case 7: return m_properties[8];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        case 3: return 3;
        case 4: return 4;
        case 5: return 5;
        case 6: return 6;
        case 7: return 7;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("mapCenterChanged(QVariant)");
        case 1: return QByteArrayLiteral("mapZoomLevelChanged(qreal)");
        case 2: return QByteArrayLiteral("mapTiltChanged(qreal)");
        case 3: return QByteArrayLiteral("mapBearingChanged(qreal)");
        case 4: return QByteArrayLiteral("nextTurnChanged(QString)");
        case 5: return QByteArrayLiteral("nextTurnDistanceMeasuredInChanged(QString)");
        case 6: return QByteArrayLiteral("nextTurnDistanceChanged(qreal)");
        case 7: return QByteArrayLiteral("routePointsChanged(QVariant)");
        case 8: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushMapCenter(QVariant)");
        case 1: return QByteArrayLiteral("pushMapZoomLevel(qreal)");
        case 2: return QByteArrayLiteral("pushMapTilt(qreal)");
        case 3: return QByteArrayLiteral("pushMapBearing(qreal)");
        case 4: return QByteArrayLiteral("pushNextTurn(QString)");
        case 5: return QByteArrayLiteral("pushNextTurnDistanceMeasuredIn(QString)");
        case 6: return QByteArrayLiteral("pushNextTurnDistance(qreal)");
        case 7: return QByteArrayLiteral("pushRoutePoints(QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        case 3: return QByteArrayLiteral("void");
        case 4: return QByteArrayLiteral("void");
        case 5: return QByteArrayLiteral("void");
        case 6: return QByteArrayLiteral("void");
        case 7: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"4436408ae3c913e1e5513ada851bb80601a2596b"}; }

    int m_enums[1];
    int m_properties[9];
    int m_signals[10];
    int m_methods[9];
    const QString m_name;
    int m_signalArgCount[9];
    const int* m_signalArgTypes[9];
    int m_methodArgCount[8];
    const int* m_methodArgTypes[8];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_NAVIGATIONSTATE_SOURCE_H
