/****************************************************************************
** Generated from 'RemoteSettings.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#include "connectionmonitoringbackend.h"

#include <QDebug>
#include <QSettings>
#include <QTimer>
#include "remotesettingsmodule.h"

Q_LOGGING_CATEGORY(qLcROConnectionMonitoring, "shared.com.pelagicore.remotesettings.connectionmonitoringbackend.remoteobjects", QtInfoMsg)


QT_BEGIN_NAMESPACE


ConnectionMonitoringBackend::ConnectionMonitoringBackend(const QString &remoteObjectsLookupName, QObject *parent)
    : ConnectionMonitoringBackendInterface(parent)
    , m_node(nullptr)
    , m_remoteObjectsLookupName(remoteObjectsLookupName)
    , m_helper(new QIviRemoteObjectReplicaHelper(qLcROConnectionMonitoring(), this))
{
    RemoteSettingsModule::registerTypes();

}

ConnectionMonitoringBackend::~ConnectionMonitoringBackend()
{
    delete m_node;
}

void ConnectionMonitoringBackend::initialize()
{

    if (!connectToNode())
        return;

    if (m_replica->isInitialized()) {
        Q_EMIT intervalMSChanged(m_replica->intervalMS());
        Q_EMIT counterChanged(m_replica->counter());
        Q_EMIT initializationDone();
    }

    QTimer::singleShot(3000, this, [this](){
        if(!m_replica->isInitialized())
            qCCritical(qLcROConnectionMonitoring) << "RemoteSettings.ConnectionMonitoring wasn't initialized within the timeout period. Please make sure the server is running.";
    });
}


void ConnectionMonitoringBackend::setIntervalMS(int intervalMS)
{
    if (m_replica.isNull())
        return;
    m_replica->pushIntervalMS(intervalMS);
}

void ConnectionMonitoringBackend::setCounter(int counter)
{
    if (m_replica.isNull())
        return;
    m_replica->pushCounter(counter);
}



bool ConnectionMonitoringBackend::connectToNode()
{
    static QString configPath;
    if (configPath.isEmpty()) {
        if (qEnvironmentVariableIsSet("SERVER_CONF_PATH")) {
            configPath = QString::fromLocal8Bit(qgetenv("SERVER_CONF_PATH"));
        } else {
            configPath = QStringLiteral("./server.conf");
            qCInfo(qLcROConnectionMonitoring) << "Environment variable SERVER_CONF_PATH not defined, using " << configPath;
        }
    }

    QSettings settings(configPath, QSettings::IniFormat);
    settings.beginGroup(QStringLiteral("remotesettings"));
    QUrl registryUrl = QUrl(settings.value(QStringLiteral("Registry"), QStringLiteral("local:remotesettings")).toString());
    if (m_url != registryUrl) {
        m_url = registryUrl;
        // QtRO doesn't allow to change the URL without destroying the Node
        delete m_node;
        m_node = new QRemoteObjectNode();
        if (!m_node->connectToNode(m_url)) {
            qCCritical(qLcROConnectionMonitoring) << "Connection to" << m_url << "failed!";
            m_replica.reset();
            return false;
        }
        qCInfo(qLcROConnectionMonitoring) << "Connecting to" << m_url;
        m_replica.reset(m_node->acquire<ConnectionMonitoringReplica>(m_remoteObjectsLookupName));
        setupConnections();
    }
    return true;
}

void ConnectionMonitoringBackend::setupConnections()
{
    connect(m_node, &QRemoteObjectNode::error, m_helper, &QIviRemoteObjectReplicaHelper::onNodeError);
    connect(m_helper, &QIviRemoteObjectReplicaHelper::errorChanged, this, &QIviFeatureInterface::errorChanged);

    connect(m_replica.data(), &QRemoteObjectReplica::stateChanged, m_helper, &QIviRemoteObjectReplicaHelper::onReplicaStateChanged);
    connect(m_replica.data(), &ConnectionMonitoringReplica::pendingResultAvailable, m_helper, &QIviRemoteObjectReplicaHelper::onPendingResultAvailable);
    //As the Replica is now initialized, this will trigger an update of all properties (not just the changed ones)
    connect(m_replica.data(), &QRemoteObjectReplica::initialized, this, &ConnectionMonitoringBackend::initialize);
    connect(m_replica.data(), &ConnectionMonitoringReplica::intervalMSChanged, this, &ConnectionMonitoringBackend::intervalMSChanged);
    connect(m_replica.data(), &ConnectionMonitoringReplica::counterChanged, this, &ConnectionMonitoringBackend::counterChanged);
}


QT_END_NAMESPACE
