/****************************************************************************
** Generated from 'RemoteSettings.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#include "systemuibackend.h"

#include <QDebug>
#include <QSettings>
#include <QTimer>
#include "remotesettingsmodule.h"

Q_LOGGING_CATEGORY(qLcROSystemUI, "shared.com.pelagicore.remotesettings.systemuibackend.remoteobjects", QtInfoMsg)


QT_BEGIN_NAMESPACE


SystemUIBackend::SystemUIBackend(const QString &remoteObjectsLookupName, QObject *parent)
    : SystemUIBackendInterface(parent)
    , m_node(nullptr)
    , m_remoteObjectsLookupName(remoteObjectsLookupName)
    , m_helper(new QIviRemoteObjectReplicaHelper(qLcROSystemUI(), this))
{
    RemoteSettingsModule::registerTypes();

}

SystemUIBackend::~SystemUIBackend()
{
    delete m_node;
}

void SystemUIBackend::initialize()
{

    if (!connectToNode())
        return;

    if (m_replica->isInitialized()) {
        Q_EMIT applicationICWindowSwitchCountChanged(m_replica->applicationICWindowSwitchCount());
        Q_EMIT initializationDone();
    }

    QTimer::singleShot(3000, this, [this](){
        if(!m_replica->isInitialized())
            qCCritical(qLcROSystemUI) << "RemoteSettings.SystemUI wasn't initialized within the timeout period. Please make sure the server is running.";
    });
}


void SystemUIBackend::setApplicationICWindowSwitchCount(int applicationICWindowSwitchCount)
{
    if (m_replica.isNull())
        return;
    m_replica->pushApplicationICWindowSwitchCount(applicationICWindowSwitchCount);
}



bool SystemUIBackend::connectToNode()
{
    static QString configPath;
    if (configPath.isEmpty()) {
        if (qEnvironmentVariableIsSet("SERVER_CONF_PATH")) {
            configPath = QString::fromLocal8Bit(qgetenv("SERVER_CONF_PATH"));
        } else {
            configPath = QStringLiteral("./server.conf");
            qCInfo(qLcROSystemUI) << "Environment variable SERVER_CONF_PATH not defined, using " << configPath;
        }
    }

    QSettings settings(configPath, QSettings::IniFormat);
    settings.beginGroup(QStringLiteral("remotesettings"));
    QUrl registryUrl = QUrl(settings.value(QStringLiteral("Registry"), QStringLiteral("local:remotesettings")).toString());
    if (m_url != registryUrl) {
        m_url = registryUrl;
        // QtRO doesn't allow to change the URL without destroying the Node
        delete m_node;
        m_node = new QRemoteObjectNode();
        if (!m_node->connectToNode(m_url)) {
            qCCritical(qLcROSystemUI) << "Connection to" << m_url << "failed!";
            m_replica.reset();
            return false;
        }
        qCInfo(qLcROSystemUI) << "Connecting to" << m_url;
        m_replica.reset(m_node->acquire<SystemUIReplica>(m_remoteObjectsLookupName));
        setupConnections();
    }
    return true;
}

void SystemUIBackend::setupConnections()
{
    connect(m_node, &QRemoteObjectNode::error, m_helper, &QIviRemoteObjectReplicaHelper::onNodeError);
    connect(m_helper, &QIviRemoteObjectReplicaHelper::errorChanged, this, &QIviFeatureInterface::errorChanged);

    connect(m_replica.data(), &QRemoteObjectReplica::stateChanged, m_helper, &QIviRemoteObjectReplicaHelper::onReplicaStateChanged);
    connect(m_replica.data(), &SystemUIReplica::pendingResultAvailable, m_helper, &QIviRemoteObjectReplicaHelper::onPendingResultAvailable);
    //As the Replica is now initialized, this will trigger an update of all properties (not just the changed ones)
    connect(m_replica.data(), &QRemoteObjectReplica::initialized, this, &SystemUIBackend::initialize);
    connect(m_replica.data(), &SystemUIReplica::applicationICWindowSwitchCountChanged, this, &SystemUIBackend::applicationICWindowSwitchCountChanged);
}


QT_END_NAMESPACE
