/****************************************************************************
** Generated from 'RemoteSettings.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#include "uisettingsbackend.h"

#include <QDebug>
#include <QSettings>
#include <QTimer>
#include "remotesettingsmodule.h"

Q_LOGGING_CATEGORY(qLcROUISettings, "shared.com.pelagicore.remotesettings.uisettingsbackend.remoteobjects", QtInfoMsg)


QT_BEGIN_NAMESPACE


UISettingsBackend::UISettingsBackend(const QString &remoteObjectsLookupName, QObject *parent)
    : UISettingsBackendInterface(parent)
    , m_node(nullptr)
    , m_remoteObjectsLookupName(remoteObjectsLookupName)
    , m_helper(new QIviRemoteObjectReplicaHelper(qLcROUISettings(), this))
{
    RemoteSettingsModule::registerTypes();

}

UISettingsBackend::~UISettingsBackend()
{
    delete m_node;
}

void UISettingsBackend::initialize()
{

    if (!connectToNode())
        return;

    if (m_replica->isInitialized()) {
        Q_EMIT languageChanged(m_replica->language());
        Q_EMIT languagesChanged(m_replica->languages());
        Q_EMIT twentyFourHourTimeFormatChanged(m_replica->twentyFourHourTimeFormat());
        Q_EMIT volumeChanged(m_replica->volume());
        Q_EMIT mutedChanged(m_replica->muted());
        Q_EMIT balanceChanged(m_replica->balance());
        Q_EMIT themeChanged(m_replica->theme());
        Q_EMIT accentColorChanged(m_replica->accentColor());
        Q_EMIT rtlModeChanged(m_replica->rtlMode());
        Q_EMIT door1OpenChanged(m_replica->door1Open());
        Q_EMIT door2OpenChanged(m_replica->door2Open());
        Q_EMIT roofOpenProgressChanged(m_replica->roofOpenProgress());
        Q_EMIT trunkOpenChanged(m_replica->trunkOpen());
        Q_EMIT navigationModeChanged(m_replica->navigationMode());
        Q_EMIT hideGaugesChanged(m_replica->hideGauges());
        Q_EMIT threeDGaugesChanged(m_replica->threeDGauges());
        Q_EMIT initializationDone();
    }

    QTimer::singleShot(3000, this, [this](){
        if(!m_replica->isInitialized())
            qCCritical(qLcROUISettings) << "RemoteSettings.UISettings wasn't initialized within the timeout period. Please make sure the server is running.";
    });
}


void UISettingsBackend::setLanguage(const QString &language)
{
    if (m_replica.isNull())
        return;
    m_replica->pushLanguage(language);
}

void UISettingsBackend::setLanguages(const QVariantList &languages)
{
    if (m_replica.isNull())
        return;
    m_replica->pushLanguages(languages);
}

void UISettingsBackend::setTwentyFourHourTimeFormat(bool twentyFourHourTimeFormat)
{
    if (m_replica.isNull())
        return;
    m_replica->pushTwentyFourHourTimeFormat(twentyFourHourTimeFormat);
}

void UISettingsBackend::setVolume(qreal volume)
{
    if (m_replica.isNull())
        return;
    m_replica->pushVolume(volume);
}

void UISettingsBackend::setMuted(bool muted)
{
    if (m_replica.isNull())
        return;
    m_replica->pushMuted(muted);
}

void UISettingsBackend::setBalance(qreal balance)
{
    if (m_replica.isNull())
        return;
    m_replica->pushBalance(balance);
}

void UISettingsBackend::setTheme(int theme)
{
    if (m_replica.isNull())
        return;
    m_replica->pushTheme(theme);
}

void UISettingsBackend::setAccentColor(const QString &accentColor)
{
    if (m_replica.isNull())
        return;
    m_replica->pushAccentColor(accentColor);
}

void UISettingsBackend::setRtlMode(bool rtlMode)
{
    if (m_replica.isNull())
        return;
    m_replica->pushRtlMode(rtlMode);
}

void UISettingsBackend::setDoor1Open(bool door1Open)
{
    if (m_replica.isNull())
        return;
    m_replica->pushDoor1Open(door1Open);
}

void UISettingsBackend::setDoor2Open(bool door2Open)
{
    if (m_replica.isNull())
        return;
    m_replica->pushDoor2Open(door2Open);
}

void UISettingsBackend::setRoofOpenProgress(qreal roofOpenProgress)
{
    if (m_replica.isNull())
        return;
    m_replica->pushRoofOpenProgress(roofOpenProgress);
}

void UISettingsBackend::setTrunkOpen(bool trunkOpen)
{
    if (m_replica.isNull())
        return;
    m_replica->pushTrunkOpen(trunkOpen);
}

void UISettingsBackend::setNavigationMode(bool navigationMode)
{
    if (m_replica.isNull())
        return;
    m_replica->pushNavigationMode(navigationMode);
}

void UISettingsBackend::setHideGauges(bool hideGauges)
{
    if (m_replica.isNull())
        return;
    m_replica->pushHideGauges(hideGauges);
}

void UISettingsBackend::setThreeDGauges(bool threeDGauges)
{
    if (m_replica.isNull())
        return;
    m_replica->pushThreeDGauges(threeDGauges);
}



bool UISettingsBackend::connectToNode()
{
    static QString configPath;
    if (configPath.isEmpty()) {
        if (qEnvironmentVariableIsSet("SERVER_CONF_PATH")) {
            configPath = QString::fromLocal8Bit(qgetenv("SERVER_CONF_PATH"));
        } else {
            configPath = QStringLiteral("./server.conf");
            qCInfo(qLcROUISettings) << "Environment variable SERVER_CONF_PATH not defined, using " << configPath;
        }
    }

    QSettings settings(configPath, QSettings::IniFormat);
    settings.beginGroup(QStringLiteral("remotesettings"));
    QUrl registryUrl = QUrl(settings.value(QStringLiteral("Registry"), QStringLiteral("local:remotesettings")).toString());
    if (m_url != registryUrl) {
        m_url = registryUrl;
        // QtRO doesn't allow to change the URL without destroying the Node
        delete m_node;
        m_node = new QRemoteObjectNode();
        if (!m_node->connectToNode(m_url)) {
            qCCritical(qLcROUISettings) << "Connection to" << m_url << "failed!";
            m_replica.reset();
            return false;
        }
        qCInfo(qLcROUISettings) << "Connecting to" << m_url;
        m_replica.reset(m_node->acquire<UISettingsReplica>(m_remoteObjectsLookupName));
        setupConnections();
    }
    return true;
}

void UISettingsBackend::setupConnections()
{
    connect(m_node, &QRemoteObjectNode::error, m_helper, &QIviRemoteObjectReplicaHelper::onNodeError);
    connect(m_helper, &QIviRemoteObjectReplicaHelper::errorChanged, this, &QIviFeatureInterface::errorChanged);

    connect(m_replica.data(), &QRemoteObjectReplica::stateChanged, m_helper, &QIviRemoteObjectReplicaHelper::onReplicaStateChanged);
    connect(m_replica.data(), &UISettingsReplica::pendingResultAvailable, m_helper, &QIviRemoteObjectReplicaHelper::onPendingResultAvailable);
    //As the Replica is now initialized, this will trigger an update of all properties (not just the changed ones)
    connect(m_replica.data(), &QRemoteObjectReplica::initialized, this, &UISettingsBackend::initialize);
    connect(m_replica.data(), &UISettingsReplica::languageChanged, this, &UISettingsBackend::languageChanged);
    connect(m_replica.data(), &UISettingsReplica::languagesChanged, this, &UISettingsBackend::languagesChanged);
    connect(m_replica.data(), &UISettingsReplica::twentyFourHourTimeFormatChanged, this, &UISettingsBackend::twentyFourHourTimeFormatChanged);
    connect(m_replica.data(), &UISettingsReplica::volumeChanged, this, &UISettingsBackend::volumeChanged);
    connect(m_replica.data(), &UISettingsReplica::mutedChanged, this, &UISettingsBackend::mutedChanged);
    connect(m_replica.data(), &UISettingsReplica::balanceChanged, this, &UISettingsBackend::balanceChanged);
    connect(m_replica.data(), &UISettingsReplica::themeChanged, this, &UISettingsBackend::themeChanged);
    connect(m_replica.data(), &UISettingsReplica::accentColorChanged, this, &UISettingsBackend::accentColorChanged);
    connect(m_replica.data(), &UISettingsReplica::rtlModeChanged, this, &UISettingsBackend::rtlModeChanged);
    connect(m_replica.data(), &UISettingsReplica::door1OpenChanged, this, &UISettingsBackend::door1OpenChanged);
    connect(m_replica.data(), &UISettingsReplica::door2OpenChanged, this, &UISettingsBackend::door2OpenChanged);
    connect(m_replica.data(), &UISettingsReplica::roofOpenProgressChanged, this, &UISettingsBackend::roofOpenProgressChanged);
    connect(m_replica.data(), &UISettingsReplica::trunkOpenChanged, this, &UISettingsBackend::trunkOpenChanged);
    connect(m_replica.data(), &UISettingsReplica::navigationModeChanged, this, &UISettingsBackend::navigationModeChanged);
    connect(m_replica.data(), &UISettingsReplica::hideGaugesChanged, this, &UISettingsBackend::hideGaugesChanged);
    connect(m_replica.data(), &UISettingsReplica::threeDGaugesChanged, this, &UISettingsBackend::threeDGaugesChanged);
}


QT_END_NAMESPACE
