#ifndef REP_CONNECTIONMONITORING_SOURCE_H
#define REP_CONNECTIONMONITORING_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include "remotesettingsmodule.h"

class ConnectionMonitoringSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "ConnectionMonitoring")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "c7092d912ad4a16d6cfc75100601afca845975bd")
    Q_PROPERTY(int intervalMS READ intervalMS WRITE setIntervalMS NOTIFY intervalMSChanged)
    Q_PROPERTY(int counter READ counter WRITE setCounter NOTIFY counterChanged)

public:
    explicit ConnectionMonitoringSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~ConnectionMonitoringSource() override = default;

    virtual int intervalMS() const = 0;
    virtual int counter() const = 0;
    virtual void setIntervalMS(int intervalMS) = 0;
    virtual void setCounter(int counter) = 0;

Q_SIGNALS:
    void intervalMSChanged(int intervalMS);
    void counterChanged(int counter);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual void pushIntervalMS(int intervalMS)
    {
        setIntervalMS(intervalMS);
    }
    virtual void pushCounter(int counter)
    {
        setCounter(counter);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class ConnectionMonitoringSimpleSource : public ConnectionMonitoringSource
{
    Q_OBJECT

public:
    explicit ConnectionMonitoringSimpleSource(QObject *parent = nullptr) : ConnectionMonitoringSource(parent)
    , m_intervalMS()
    , m_counter()
    {
    }

public:
    ~ConnectionMonitoringSimpleSource() override = default;

    int intervalMS() const override { return m_intervalMS; }
    int counter() const override { return m_counter; }
    void setIntervalMS(int intervalMS) override
    {
        if (intervalMS != m_intervalMS) {
            m_intervalMS = intervalMS;
            Q_EMIT intervalMSChanged(m_intervalMS);
        }
    }
    void setCounter(int counter) override
    {
        if (counter != m_counter) {
            m_counter = counter;
            Q_EMIT counterChanged(m_counter);
        }
    }

private:
    int m_intervalMS;
    int m_counter;
};


template <class ObjectType>
struct ConnectionMonitoringSourceAPI : public SourceApiMap
{
    ConnectionMonitoringSourceAPI(ObjectType *object, const QString &name = QLatin1String("ConnectionMonitoring"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 2;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::intervalMS, static_cast<int (QObject::*)()>(0),"intervalMS");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::intervalMSChanged, static_cast<void (QObject::*)()>(0));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::counter, static_cast<int (QObject::*)()>(0),"counter");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::counterChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 3;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::intervalMSChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::counterChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushIntervalMS, static_cast<void (QObject::*)(int)>(0),"pushIntervalMS(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushCounter, static_cast<void (QObject::*)(int)>(0),"pushCounter(int)",m_methodArgCount+1,&m_methodArgTypes[1]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("ConnectionMonitoring"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("intervalMSChanged(int)");
        case 1: return QByteArrayLiteral("counterChanged(int)");
        case 2: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushIntervalMS(int)");
        case 1: return QByteArrayLiteral("pushCounter(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"c7092d912ad4a16d6cfc75100601afca845975bd"}; }

    int m_enums[1];
    int m_properties[3];
    int m_signals[4];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[3];
    const int* m_signalArgTypes[3];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_CONNECTIONMONITORING_SOURCE_H
