#ifndef REP_SYSTEMUI_SOURCE_H
#define REP_SYSTEMUI_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include "remotesettingsmodule.h"

class SystemUISource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "SystemUI")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "c9cfd8c6c7d09a6eaed16180bc070dae1fab12fc")
    Q_PROPERTY(int applicationICWindowSwitchCount READ applicationICWindowSwitchCount WRITE setApplicationICWindowSwitchCount NOTIFY applicationICWindowSwitchCountChanged)

public:
    explicit SystemUISource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~SystemUISource() override = default;

    virtual int applicationICWindowSwitchCount() const = 0;
    virtual void setApplicationICWindowSwitchCount(int applicationICWindowSwitchCount) = 0;

Q_SIGNALS:
    void applicationICWindowSwitchCountChanged(int applicationICWindowSwitchCount);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual void pushApplicationICWindowSwitchCount(int applicationICWindowSwitchCount)
    {
        setApplicationICWindowSwitchCount(applicationICWindowSwitchCount);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class SystemUISimpleSource : public SystemUISource
{
    Q_OBJECT

public:
    explicit SystemUISimpleSource(QObject *parent = nullptr) : SystemUISource(parent)
    , m_applicationICWindowSwitchCount()
    {
    }

public:
    ~SystemUISimpleSource() override = default;

    int applicationICWindowSwitchCount() const override { return m_applicationICWindowSwitchCount; }
    void setApplicationICWindowSwitchCount(int applicationICWindowSwitchCount) override
    {
        if (applicationICWindowSwitchCount != m_applicationICWindowSwitchCount) {
            m_applicationICWindowSwitchCount = applicationICWindowSwitchCount;
            Q_EMIT applicationICWindowSwitchCountChanged(m_applicationICWindowSwitchCount);
        }
    }

private:
    int m_applicationICWindowSwitchCount;
};


template <class ObjectType>
struct SystemUISourceAPI : public SourceApiMap
{
    SystemUISourceAPI(ObjectType *object, const QString &name = QLatin1String("SystemUI"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::applicationICWindowSwitchCount, static_cast<int (QObject::*)()>(0),"applicationICWindowSwitchCount");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::applicationICWindowSwitchCountChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 2;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::applicationICWindowSwitchCountChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_methods[0] = 1;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushApplicationICWindowSwitchCount, static_cast<void (QObject::*)(int)>(0),"pushApplicationICWindowSwitchCount(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("SystemUI"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("applicationICWindowSwitchCountChanged(int)");
        case 1: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushApplicationICWindowSwitchCount(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"c9cfd8c6c7d09a6eaed16180bc070dae1fab12fc"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[3];
    int m_methods[2];
    const QString m_name;
    int m_signalArgCount[2];
    const int* m_signalArgTypes[2];
    int m_methodArgCount[1];
    const int* m_methodArgTypes[1];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_SYSTEMUI_SOURCE_H
