#ifndef REP_UISETTINGS_SOURCE_H
#define REP_UISETTINGS_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include "remotesettingsmodule.h"

class UISettingsSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "UISettings")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "3266d324ddb25cce05d1ea98d17605cdda56c1f1")
    Q_PROPERTY(QString language READ language WRITE setLanguage NOTIFY languageChanged)
    Q_PROPERTY(QVariantList languages READ languages WRITE setLanguages NOTIFY languagesChanged)
    Q_PROPERTY(bool twentyFourHourTimeFormat READ twentyFourHourTimeFormat WRITE setTwentyFourHourTimeFormat NOTIFY twentyFourHourTimeFormatChanged)
    Q_PROPERTY(qreal volume READ volume WRITE setVolume NOTIFY volumeChanged)
    Q_PROPERTY(bool muted READ muted WRITE setMuted NOTIFY mutedChanged)
    Q_PROPERTY(qreal balance READ balance WRITE setBalance NOTIFY balanceChanged)
    Q_PROPERTY(int theme READ theme WRITE setTheme NOTIFY themeChanged)
    Q_PROPERTY(QString accentColor READ accentColor WRITE setAccentColor NOTIFY accentColorChanged)
    Q_PROPERTY(bool rtlMode READ rtlMode WRITE setRtlMode NOTIFY rtlModeChanged)
    Q_PROPERTY(bool door1Open READ door1Open WRITE setDoor1Open NOTIFY door1OpenChanged)
    Q_PROPERTY(bool door2Open READ door2Open WRITE setDoor2Open NOTIFY door2OpenChanged)
    Q_PROPERTY(qreal roofOpenProgress READ roofOpenProgress WRITE setRoofOpenProgress NOTIFY roofOpenProgressChanged)
    Q_PROPERTY(bool trunkOpen READ trunkOpen WRITE setTrunkOpen NOTIFY trunkOpenChanged)
    Q_PROPERTY(bool navigationMode READ navigationMode WRITE setNavigationMode NOTIFY navigationModeChanged)
    Q_PROPERTY(bool hideGauges READ hideGauges WRITE setHideGauges NOTIFY hideGaugesChanged)
    Q_PROPERTY(bool threeDGauges READ threeDGauges WRITE setThreeDGauges NOTIFY threeDGaugesChanged)

public:
    explicit UISettingsSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~UISettingsSource() override = default;

    virtual QString language() const = 0;
    virtual QVariantList languages() const = 0;
    virtual bool twentyFourHourTimeFormat() const = 0;
    virtual qreal volume() const = 0;
    virtual bool muted() const = 0;
    virtual qreal balance() const = 0;
    virtual int theme() const = 0;
    virtual QString accentColor() const = 0;
    virtual bool rtlMode() const = 0;
    virtual bool door1Open() const = 0;
    virtual bool door2Open() const = 0;
    virtual qreal roofOpenProgress() const = 0;
    virtual bool trunkOpen() const = 0;
    virtual bool navigationMode() const = 0;
    virtual bool hideGauges() const = 0;
    virtual bool threeDGauges() const = 0;
    virtual void setLanguage(QString language) = 0;
    virtual void setLanguages(QVariantList languages) = 0;
    virtual void setTwentyFourHourTimeFormat(bool twentyFourHourTimeFormat) = 0;
    virtual void setVolume(qreal volume) = 0;
    virtual void setMuted(bool muted) = 0;
    virtual void setBalance(qreal balance) = 0;
    virtual void setTheme(int theme) = 0;
    virtual void setAccentColor(QString accentColor) = 0;
    virtual void setRtlMode(bool rtlMode) = 0;
    virtual void setDoor1Open(bool door1Open) = 0;
    virtual void setDoor2Open(bool door2Open) = 0;
    virtual void setRoofOpenProgress(qreal roofOpenProgress) = 0;
    virtual void setTrunkOpen(bool trunkOpen) = 0;
    virtual void setNavigationMode(bool navigationMode) = 0;
    virtual void setHideGauges(bool hideGauges) = 0;
    virtual void setThreeDGauges(bool threeDGauges) = 0;

Q_SIGNALS:
    void languageChanged(QString language);
    void languagesChanged(QVariantList languages);
    void twentyFourHourTimeFormatChanged(bool twentyFourHourTimeFormat);
    void volumeChanged(qreal volume);
    void mutedChanged(bool muted);
    void balanceChanged(qreal balance);
    void themeChanged(int theme);
    void accentColorChanged(QString accentColor);
    void rtlModeChanged(bool rtlMode);
    void door1OpenChanged(bool door1Open);
    void door2OpenChanged(bool door2Open);
    void roofOpenProgressChanged(qreal roofOpenProgress);
    void trunkOpenChanged(bool trunkOpen);
    void navigationModeChanged(bool navigationMode);
    void hideGaugesChanged(bool hideGauges);
    void threeDGaugesChanged(bool threeDGauges);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual void pushLanguage(QString language)
    {
        setLanguage(language);
    }
    virtual void pushLanguages(QVariantList languages)
    {
        setLanguages(languages);
    }
    virtual void pushTwentyFourHourTimeFormat(bool twentyFourHourTimeFormat)
    {
        setTwentyFourHourTimeFormat(twentyFourHourTimeFormat);
    }
    virtual void pushVolume(qreal volume)
    {
        setVolume(volume);
    }
    virtual void pushMuted(bool muted)
    {
        setMuted(muted);
    }
    virtual void pushBalance(qreal balance)
    {
        setBalance(balance);
    }
    virtual void pushTheme(int theme)
    {
        setTheme(theme);
    }
    virtual void pushAccentColor(QString accentColor)
    {
        setAccentColor(accentColor);
    }
    virtual void pushRtlMode(bool rtlMode)
    {
        setRtlMode(rtlMode);
    }
    virtual void pushDoor1Open(bool door1Open)
    {
        setDoor1Open(door1Open);
    }
    virtual void pushDoor2Open(bool door2Open)
    {
        setDoor2Open(door2Open);
    }
    virtual void pushRoofOpenProgress(qreal roofOpenProgress)
    {
        setRoofOpenProgress(roofOpenProgress);
    }
    virtual void pushTrunkOpen(bool trunkOpen)
    {
        setTrunkOpen(trunkOpen);
    }
    virtual void pushNavigationMode(bool navigationMode)
    {
        setNavigationMode(navigationMode);
    }
    virtual void pushHideGauges(bool hideGauges)
    {
        setHideGauges(hideGauges);
    }
    virtual void pushThreeDGauges(bool threeDGauges)
    {
        setThreeDGauges(threeDGauges);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class UISettingsSimpleSource : public UISettingsSource
{
    Q_OBJECT

public:
    explicit UISettingsSimpleSource(QObject *parent = nullptr) : UISettingsSource(parent)
    , m_language()
    , m_languages()
    , m_twentyFourHourTimeFormat()
    , m_volume()
    , m_muted()
    , m_balance()
    , m_theme()
    , m_accentColor()
    , m_rtlMode()
    , m_door1Open()
    , m_door2Open()
    , m_roofOpenProgress()
    , m_trunkOpen()
    , m_navigationMode()
    , m_hideGauges()
    , m_threeDGauges()
    {
    }

public:
    ~UISettingsSimpleSource() override = default;

    QString language() const override { return m_language; }
    QVariantList languages() const override { return m_languages; }
    bool twentyFourHourTimeFormat() const override { return m_twentyFourHourTimeFormat; }
    qreal volume() const override { return m_volume; }
    bool muted() const override { return m_muted; }
    qreal balance() const override { return m_balance; }
    int theme() const override { return m_theme; }
    QString accentColor() const override { return m_accentColor; }
    bool rtlMode() const override { return m_rtlMode; }
    bool door1Open() const override { return m_door1Open; }
    bool door2Open() const override { return m_door2Open; }
    qreal roofOpenProgress() const override { return m_roofOpenProgress; }
    bool trunkOpen() const override { return m_trunkOpen; }
    bool navigationMode() const override { return m_navigationMode; }
    bool hideGauges() const override { return m_hideGauges; }
    bool threeDGauges() const override { return m_threeDGauges; }
    void setLanguage(QString language) override
    {
        if (language != m_language) {
            m_language = language;
            Q_EMIT languageChanged(m_language);
        }
    }
    void setLanguages(QVariantList languages) override
    {
        if (languages != m_languages) {
            m_languages = languages;
            Q_EMIT languagesChanged(m_languages);
        }
    }
    void setTwentyFourHourTimeFormat(bool twentyFourHourTimeFormat) override
    {
        if (twentyFourHourTimeFormat != m_twentyFourHourTimeFormat) {
            m_twentyFourHourTimeFormat = twentyFourHourTimeFormat;
            Q_EMIT twentyFourHourTimeFormatChanged(m_twentyFourHourTimeFormat);
        }
    }
    void setVolume(qreal volume) override
    {
        if (volume != m_volume) {
            m_volume = volume;
            Q_EMIT volumeChanged(m_volume);
        }
    }
    void setMuted(bool muted) override
    {
        if (muted != m_muted) {
            m_muted = muted;
            Q_EMIT mutedChanged(m_muted);
        }
    }
    void setBalance(qreal balance) override
    {
        if (balance != m_balance) {
            m_balance = balance;
            Q_EMIT balanceChanged(m_balance);
        }
    }
    void setTheme(int theme) override
    {
        if (theme != m_theme) {
            m_theme = theme;
            Q_EMIT themeChanged(m_theme);
        }
    }
    void setAccentColor(QString accentColor) override
    {
        if (accentColor != m_accentColor) {
            m_accentColor = accentColor;
            Q_EMIT accentColorChanged(m_accentColor);
        }
    }
    void setRtlMode(bool rtlMode) override
    {
        if (rtlMode != m_rtlMode) {
            m_rtlMode = rtlMode;
            Q_EMIT rtlModeChanged(m_rtlMode);
        }
    }
    void setDoor1Open(bool door1Open) override
    {
        if (door1Open != m_door1Open) {
            m_door1Open = door1Open;
            Q_EMIT door1OpenChanged(m_door1Open);
        }
    }
    void setDoor2Open(bool door2Open) override
    {
        if (door2Open != m_door2Open) {
            m_door2Open = door2Open;
            Q_EMIT door2OpenChanged(m_door2Open);
        }
    }
    void setRoofOpenProgress(qreal roofOpenProgress) override
    {
        if (roofOpenProgress != m_roofOpenProgress) {
            m_roofOpenProgress = roofOpenProgress;
            Q_EMIT roofOpenProgressChanged(m_roofOpenProgress);
        }
    }
    void setTrunkOpen(bool trunkOpen) override
    {
        if (trunkOpen != m_trunkOpen) {
            m_trunkOpen = trunkOpen;
            Q_EMIT trunkOpenChanged(m_trunkOpen);
        }
    }
    void setNavigationMode(bool navigationMode) override
    {
        if (navigationMode != m_navigationMode) {
            m_navigationMode = navigationMode;
            Q_EMIT navigationModeChanged(m_navigationMode);
        }
    }
    void setHideGauges(bool hideGauges) override
    {
        if (hideGauges != m_hideGauges) {
            m_hideGauges = hideGauges;
            Q_EMIT hideGaugesChanged(m_hideGauges);
        }
    }
    void setThreeDGauges(bool threeDGauges) override
    {
        if (threeDGauges != m_threeDGauges) {
            m_threeDGauges = threeDGauges;
            Q_EMIT threeDGaugesChanged(m_threeDGauges);
        }
    }

private:
    QString m_language;
    QVariantList m_languages;
    bool m_twentyFourHourTimeFormat;
    qreal m_volume;
    bool m_muted;
    qreal m_balance;
    int m_theme;
    QString m_accentColor;
    bool m_rtlMode;
    bool m_door1Open;
    bool m_door2Open;
    qreal m_roofOpenProgress;
    bool m_trunkOpen;
    bool m_navigationMode;
    bool m_hideGauges;
    bool m_threeDGauges;
};


template <class ObjectType>
struct UISettingsSourceAPI : public SourceApiMap
{
    UISettingsSourceAPI(ObjectType *object, const QString &name = QLatin1String("UISettings"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 16;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::language, static_cast<QString (QObject::*)()>(0),"language");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::languageChanged, static_cast<void (QObject::*)()>(0));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::languages, static_cast<QVariantList (QObject::*)()>(0),"languages");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::languagesChanged, static_cast<void (QObject::*)()>(0));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::twentyFourHourTimeFormat, static_cast<bool (QObject::*)()>(0),"twentyFourHourTimeFormat");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::twentyFourHourTimeFormatChanged, static_cast<void (QObject::*)()>(0));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::volume, static_cast<qreal (QObject::*)()>(0),"volume");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::volumeChanged, static_cast<void (QObject::*)()>(0));
        m_properties[5] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::muted, static_cast<bool (QObject::*)()>(0),"muted");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mutedChanged, static_cast<void (QObject::*)()>(0));
        m_properties[6] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::balance, static_cast<qreal (QObject::*)()>(0),"balance");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::balanceChanged, static_cast<void (QObject::*)()>(0));
        m_properties[7] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::theme, static_cast<int (QObject::*)()>(0),"theme");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::themeChanged, static_cast<void (QObject::*)()>(0));
        m_properties[8] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::accentColor, static_cast<QString (QObject::*)()>(0),"accentColor");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::accentColorChanged, static_cast<void (QObject::*)()>(0));
        m_properties[9] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::rtlMode, static_cast<bool (QObject::*)()>(0),"rtlMode");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::rtlModeChanged, static_cast<void (QObject::*)()>(0));
        m_properties[10] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::door1Open, static_cast<bool (QObject::*)()>(0),"door1Open");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::door1OpenChanged, static_cast<void (QObject::*)()>(0));
        m_properties[11] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::door2Open, static_cast<bool (QObject::*)()>(0),"door2Open");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::door2OpenChanged, static_cast<void (QObject::*)()>(0));
        m_properties[12] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::roofOpenProgress, static_cast<qreal (QObject::*)()>(0),"roofOpenProgress");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::roofOpenProgressChanged, static_cast<void (QObject::*)()>(0));
        m_properties[13] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::trunkOpen, static_cast<bool (QObject::*)()>(0),"trunkOpen");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::trunkOpenChanged, static_cast<void (QObject::*)()>(0));
        m_properties[14] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::navigationMode, static_cast<bool (QObject::*)()>(0),"navigationMode");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::navigationModeChanged, static_cast<void (QObject::*)()>(0));
        m_properties[15] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::hideGauges, static_cast<bool (QObject::*)()>(0),"hideGauges");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::hideGaugesChanged, static_cast<void (QObject::*)()>(0));
        m_properties[16] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::threeDGauges, static_cast<bool (QObject::*)()>(0),"threeDGauges");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::threeDGaugesChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 17;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::languageChanged, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::languagesChanged, static_cast<void (QObject::*)(QVariantList)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::twentyFourHourTimeFormatChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::volumeChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mutedChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::balanceChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_signals[7] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::themeChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+6,&m_signalArgTypes[6]);
        m_signals[8] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::accentColorChanged, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+7,&m_signalArgTypes[7]);
        m_signals[9] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::rtlModeChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+8,&m_signalArgTypes[8]);
        m_signals[10] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::door1OpenChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+9,&m_signalArgTypes[9]);
        m_signals[11] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::door2OpenChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+10,&m_signalArgTypes[10]);
        m_signals[12] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::roofOpenProgressChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+11,&m_signalArgTypes[11]);
        m_signals[13] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::trunkOpenChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+12,&m_signalArgTypes[12]);
        m_signals[14] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::navigationModeChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+13,&m_signalArgTypes[13]);
        m_signals[15] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::hideGaugesChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+14,&m_signalArgTypes[14]);
        m_signals[16] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::threeDGaugesChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+15,&m_signalArgTypes[15]);
        m_signals[17] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+16,&m_signalArgTypes[16]);
        m_methods[0] = 16;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushLanguage, static_cast<void (QObject::*)(QString)>(0),"pushLanguage(QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushLanguages, static_cast<void (QObject::*)(QVariantList)>(0),"pushLanguages(QVariantList)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushTwentyFourHourTimeFormat, static_cast<void (QObject::*)(bool)>(0),"pushTwentyFourHourTimeFormat(bool)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushVolume, static_cast<void (QObject::*)(qreal)>(0),"pushVolume(qreal)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMuted, static_cast<void (QObject::*)(bool)>(0),"pushMuted(bool)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushBalance, static_cast<void (QObject::*)(qreal)>(0),"pushBalance(qreal)",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushTheme, static_cast<void (QObject::*)(int)>(0),"pushTheme(int)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushAccentColor, static_cast<void (QObject::*)(QString)>(0),"pushAccentColor(QString)",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_methods[9] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushRtlMode, static_cast<void (QObject::*)(bool)>(0),"pushRtlMode(bool)",m_methodArgCount+8,&m_methodArgTypes[8]);
        m_methods[10] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushDoor1Open, static_cast<void (QObject::*)(bool)>(0),"pushDoor1Open(bool)",m_methodArgCount+9,&m_methodArgTypes[9]);
        m_methods[11] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushDoor2Open, static_cast<void (QObject::*)(bool)>(0),"pushDoor2Open(bool)",m_methodArgCount+10,&m_methodArgTypes[10]);
        m_methods[12] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushRoofOpenProgress, static_cast<void (QObject::*)(qreal)>(0),"pushRoofOpenProgress(qreal)",m_methodArgCount+11,&m_methodArgTypes[11]);
        m_methods[13] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushTrunkOpen, static_cast<void (QObject::*)(bool)>(0),"pushTrunkOpen(bool)",m_methodArgCount+12,&m_methodArgTypes[12]);
        m_methods[14] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushNavigationMode, static_cast<void (QObject::*)(bool)>(0),"pushNavigationMode(bool)",m_methodArgCount+13,&m_methodArgTypes[13]);
        m_methods[15] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushHideGauges, static_cast<void (QObject::*)(bool)>(0),"pushHideGauges(bool)",m_methodArgCount+14,&m_methodArgTypes[14]);
        m_methods[16] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushThreeDGauges, static_cast<void (QObject::*)(bool)>(0),"pushThreeDGauges(bool)",m_methodArgCount+15,&m_methodArgTypes[15]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("UISettings"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        case 3: return m_properties[4];
        case 4: return m_properties[5];
        case 5: return m_properties[6];
        case 6: return m_properties[7];
        case 7: return m_properties[8];
        case 8: return m_properties[9];
        case 9: return m_properties[10];
        case 10: return m_properties[11];
        case 11: return m_properties[12];
        case 12: return m_properties[13];
        case 13: return m_properties[14];
        case 14: return m_properties[15];
        case 15: return m_properties[16];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        case 3: return 3;
        case 4: return 4;
        case 5: return 5;
        case 6: return 6;
        case 7: return 7;
        case 8: return 8;
        case 9: return 9;
        case 10: return 10;
        case 11: return 11;
        case 12: return 12;
        case 13: return 13;
        case 14: return 14;
        case 15: return 15;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("languageChanged(QString)");
        case 1: return QByteArrayLiteral("languagesChanged(QVariantList)");
        case 2: return QByteArrayLiteral("twentyFourHourTimeFormatChanged(bool)");
        case 3: return QByteArrayLiteral("volumeChanged(qreal)");
        case 4: return QByteArrayLiteral("mutedChanged(bool)");
        case 5: return QByteArrayLiteral("balanceChanged(qreal)");
        case 6: return QByteArrayLiteral("themeChanged(int)");
        case 7: return QByteArrayLiteral("accentColorChanged(QString)");
        case 8: return QByteArrayLiteral("rtlModeChanged(bool)");
        case 9: return QByteArrayLiteral("door1OpenChanged(bool)");
        case 10: return QByteArrayLiteral("door2OpenChanged(bool)");
        case 11: return QByteArrayLiteral("roofOpenProgressChanged(qreal)");
        case 12: return QByteArrayLiteral("trunkOpenChanged(bool)");
        case 13: return QByteArrayLiteral("navigationModeChanged(bool)");
        case 14: return QByteArrayLiteral("hideGaugesChanged(bool)");
        case 15: return QByteArrayLiteral("threeDGaugesChanged(bool)");
        case 16: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushLanguage(QString)");
        case 1: return QByteArrayLiteral("pushLanguages(QVariantList)");
        case 2: return QByteArrayLiteral("pushTwentyFourHourTimeFormat(bool)");
        case 3: return QByteArrayLiteral("pushVolume(qreal)");
        case 4: return QByteArrayLiteral("pushMuted(bool)");
        case 5: return QByteArrayLiteral("pushBalance(qreal)");
        case 6: return QByteArrayLiteral("pushTheme(int)");
        case 7: return QByteArrayLiteral("pushAccentColor(QString)");
        case 8: return QByteArrayLiteral("pushRtlMode(bool)");
        case 9: return QByteArrayLiteral("pushDoor1Open(bool)");
        case 10: return QByteArrayLiteral("pushDoor2Open(bool)");
        case 11: return QByteArrayLiteral("pushRoofOpenProgress(qreal)");
        case 12: return QByteArrayLiteral("pushTrunkOpen(bool)");
        case 13: return QByteArrayLiteral("pushNavigationMode(bool)");
        case 14: return QByteArrayLiteral("pushHideGauges(bool)");
        case 15: return QByteArrayLiteral("pushThreeDGauges(bool)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        case 3: return QByteArrayLiteral("void");
        case 4: return QByteArrayLiteral("void");
        case 5: return QByteArrayLiteral("void");
        case 6: return QByteArrayLiteral("void");
        case 7: return QByteArrayLiteral("void");
        case 8: return QByteArrayLiteral("void");
        case 9: return QByteArrayLiteral("void");
        case 10: return QByteArrayLiteral("void");
        case 11: return QByteArrayLiteral("void");
        case 12: return QByteArrayLiteral("void");
        case 13: return QByteArrayLiteral("void");
        case 14: return QByteArrayLiteral("void");
        case 15: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"3266d324ddb25cce05d1ea98d17605cdda56c1f1"}; }

    int m_enums[1];
    int m_properties[17];
    int m_signals[18];
    int m_methods[17];
    const QString m_name;
    int m_signalArgCount[17];
    const int* m_signalArgTypes[17];
    int m_methodArgCount[16];
    const int* m_methodArgTypes[16];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_UISETTINGS_SOURCE_H
